/*                                                                          
  Ŀ
   Ejemplo3.c                                                             
                                                                          
   Ejemplo de uso de interrupciones software de la ROM-BIOS usando la int 
   10h mediante la librera INTS.H:                                       
   Inicializacin del modo de video 12h (640x480x16) y relleno de pixels  
   de la pantalla con distintos colores.                                  
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  [NoP] de Compiler SoftWare.                     
  1997 C.S.
*/

#include <stdio.h>               /* funciones estndar Input/Output */
#include <conio.h>               /* funcin getch(); */
#include <stdlib.h>              /* funcin random(); */
#include "ints.h"                /* librera con funciones varias int 10h */

int buclex, bucley;

/*  Funcin principal main()  */

void main( void )
{

 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */

 printf("EJEMPLO3.EXE\r\n");
 printf("\r\nEn este ejemplo inicializamos el modo grfico 640x480x16 (12h)\r\n");
 printf("para testear la funcin Int_PutPixel() (dibujo de pixels con la Int 10h,\r\n");
 printf("servicio 0Ch), aunque el uso de interrupciones es MUY lento.\r\n");
 printf("\r\nBIOS Int 10h:   Write Graphics Pixel.\r\n");
 printf("                    AH = 0Ch\r\n");
 printf("               (CX,DX) = (x,y) del pixel\r\n");
 printf("                    AL = Color\r\n\n");
 
 printf("Pulse cualquier tecla para realizar la prueba...");
 getch();

 SetVideoMode( 0x12 );                    /* inicializar 640x480x16 (12h) */

 for( bucley=0; bucley<480; bucley++ )
   for( buclex=0; buclex<640; buclex++ )
     Int_PutPixel( buclex, bucley, random(16) );

 getch();                                 /* esperar a que pulse una tecla */
 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */

 printf("Como ha demostrado este ejemplo, es imposible realizar programas rpidos\r\n");
 printf("dibujando en pantalla con interrupciones. Otra cosa distinta es inicializar\r\n");
 printf("el modo de video. Slo se realiza una vez al principio del programa, por lo\r\n");
 printf("que nos basta con usar SetVideoMode en vez de programar directamente la\r\n");
 printf("tarjeta (sera una locura programar sus registros internos tan slo para\r\n");
 printf("inicializar modos de video estndar).\r\n\n");
 printf("Un comentario acerca de Int_PutPixel(). Intentar obtener velocidad de una\r\n");
 printf("interrupcin es poco menos que imposible. Las funciones de acceso a VRAM\r\n");
 printf("que crearemos aqu son muchsimo ms rpidas, sobre todo en 320x200x256.\r\n");
}
