;        
;        
; F256.asm
; 10/11/1996 [NoP] para Compiler SoftWare.
; Creado con TASM 3.2 por Santiago Romero Iglesias.
;
; [NOP]                                                            \:-)
;        

        .MODEL TINY 
        .286

;============================== CODE SEGMENT ============================
        .CODE

        org 100h

Inicio:
        jmp START

START:
        mov ax, 13h
        int 10h                             ; iniciar VGA 13h 320x200

        mov di, offset Buffer
        mov cx, 80*50
        xor al, al
        rep stosb

;
; Generamos la paleta del fuego (odio generar las paletas... :-/ )
;
        
        mov dx, 03c8h
        xor ax, ax
        out dx, al                          ; DAC Port (3c8h) = 0
        inc dx                              ; DX = 3c9h

PalLoop:
        mov al, ah                          ; R = 0 to 63
        out dx, al
        xor al, al
        out dx, al                          ; G = 0
        out dx, al                          ; B = 0

        inc ah
        cmp ah, 63                          ; de 0 a 63 hay un gradiente de
        jb PalLoop                          ; rojos, desde negro a rojo puro

        xor bl, bl                          ; ahora con R=63 (mx), vamos a
PalLoop2:                                   ; mantener B a 0 y a subir G de
        mov al, 63                          ; 0 a 63 (rojo -> amarillo)
        out dx, al
        mov al, bl
        out dx, al                          ; G = 0 a 63
        xor al, al
        out dx, al                          ; B = 0

        inc bl   
        cmp bl, 63
        jb PalLoop2                         ; tenemos generados 128 colores

;;;;;;;;;;;;;;;;;;;;;;; DE ESTO SE PUEDE PRESCINDIR ;;;;;;;;;;;;;;;;;;;;;;;
        xor al, al
        mov cx, 768/2
PalLoop3:
        out dx, al
        loop PalLoop3                      ; restantes 128 colores a 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;
; El Duplicate Scan Row register lo modificamos a 4 (3+1).
;

        mov dx, 3d4h                        ; reprogramar Misc. Register
        mov al, 9                           ; Duplicate Scan Row register
        out dx, al
        inc dx
        in al, dx
        and al, 01110000b
        add al, 128                         ; (+bit 7)
        add al, 3                           ; Double Scan especificado
        out dx, al                          ; DoubleScan = 4 veces por Scan

        mov ax, 0a000h
        mov es, ax                          ; ES = Segmento VGA


MainLoop:

;
; CalcFireFrame
; Genera en Buffer un nuevo fotograma del fuego.
;
        
        mov si, offset Buffer               ; DS:SI = Buffer fuego
        mov cx, 80*51                       ; Repetir para 4000 bytes
        xor ah, ah                          ; borramos AH para operar luego
        xor bh, bh                          ; y hacemos igual con BH

CalcFireLoop:                               ; bucle para calcular la media
        mov bl, [si]                        ; V1 = Buffer[X,Y]
        mov al, [si+79]                     ; V2 = Buffer[X-1,Y+1]
        add bx, ax
        mov al, [si+80]                     ; V3 = Buffer[X,Y+1]
        add bx, ax
        mov al, [si+81]                     ; V4 = Buffer[X+1,Y+1]
        add bx, ax                          ; BX = V1+V2+V3+V4

        shr bx , 2                          ; BX = BX/4 (Media de los 4)
        jz NoResta                          ; es cero el resultado?
        dec bl                              ; no, puedes restar (para apagar)

NoResta:                                    ; BL = valor medio de los 4
        mov [si], bl                        ; Buffer[x,y] = BL
        inc si                              ; siguiente byte (x++)

        dec cx                              ; fin del buffer?
        jnz CalcFireLoop                    ; no, continuar con el bucle

        mov cl , 80                         ; poner 80 nuevos HotSpots

BucleRelleno:
        
        mov al, cs:[RandSeed]
        mov bl, cs:[RandSeed2]
        add al, 0a1h
        add bl, 0f7h
        rol al, 2
        mov cs:[RandSeed], al
        add bl, al
        ror bl, 1
        mov cs:[RandSeed2], bl              ; generacin de numeros aleat.
        add al, bl                          ; AL = Nmero 0-255
        
        and al, 128                         ; AL = n entre 0 y 128
        add al, 20                          ; Para ms brillo del fuego
        mov [si], al                        ; Ponemos el byte en el buffer
        inc si                              ; siguiente byte del buffer
        
        dec cl                              ; es el ltimo byte?
        jnz BucleRelleno                    ; no, continuar con el bucle


;
; WaitVRetrace
; Espera a que acabe el retrazado y comience el retrazo de la VGA.
;
        
        mov dx, 03dah                       ; VGA Status Port
        in al, dx
        test al, 08h
        jz $-5                              ; esperar inicio de v-retrace
        

;
; DrawFire
; Dibuja en pantalla el contenido de Buffer en sistema 2x2 ampliado.
;

        mov di, 320                         ; dibujar en lnea 50 doubled
        mov si, offset Buffer               ; DS:SI = Buffer fuego.
         
        mov dx, 80*49                       ; no dibujar ltima lnea (50)

LineLoop:
        lodsb                               ; AL = DS:[SI]
        mov ah, al                          ; AH = AL (AX para stosw)
        stosw
        stosw                               ; pixels de 4x4

        dec dx
        jnz LineLoop                        ; repetir 80*49 veces


;
; Comprobar si se ha pulsado alguna tecla para salir...
;

        in al, 60h                          ; leer del puerto de teclado
        test al, 80h                        ; se ha pulsado alguna tecla?
        jnz MainLoop                        ; no -> repetir MainLoop

Exit:
        mov ax, 3h
        int 10h                             ; volver a modo texto 80x25

        mov dx, offset EndMsg
        mov ah, 9
        int 21h                             ; imprimir mensaje final.
        ret


;

;
;== Datos incluidos en la demo (CS) =======================================
;

RandSeed  DB 08Bh
RandSeed2 DB 07Fh
RandSeed3 DB 0BFh                           ; semillas de nmeros aleatorios

EndMsg    DB 'Coded by [NoP]', 10, 13
          DB '100% assembler.', 10, 13,'$'

Buffer    DB 4000 DUP(?)                    ; Buffer del efecto fuego

END Inicio

;; [1996 Compiler SoftWare]
;;    [ FIN DE FICHERO ]
